/*  ---rgf, 2008-06-10 fr Herrn Frysak */

xScriptContext=uno.getScriptContext()        /* get the xScriptContext object                   */
oDoc=xScriptContext~getDocument              /* get the document service (a XModel) object      */
/*
xDesktop=xScriptContext~getDesktop           /* get the desktop (a XDesktop) object             */
xContext=xScriptContext~getComponentContext  /* get the context (a XComponentContext) object    */
*/

      /* replace the following part with your code (begin) ==> */
      /* demonstration of how to interact with different document types */
str="Hello world ["date("s") time()"] by http://www.ooRexx.org! "    /* define some text        */

methods="getClassPath getDescription getLanguage getLanguageName getLanguageProperties" -
        "getLocation getLogicalName getLocationPlaceHolder getParcelLocation"           -
        "getScriptFullURL  getShortFormScriptURL           loadSource hasSource getSource getSourceBytes getSourceURL"

methods=methods~space~makearray(" ")

metaData=uno.getScriptMetaData()          /* get the script's metadata */


sSrvc = "com.sun.star.script.provider.ScriptURIHelper"

mArgs = uno.createArray(.bsf4rexx~string.class, 2) /* create a java.lang.String array */
mArgs[1]="ooRexx"    /* assign first argument   */
mArgs[2]="document"  /* assign second argument  */

oScriptURIHelper = oSM~createInstanceWithArgumentsAndContext(sSrvc,mArgs,xScriptContext)
xScriptURIHelper = oScriptURIHelper~XScriptUriHelper  /* query its interface     */

   /* query the storage URI of this language root directory */
say xScriptURIHelper~getRootStorageURI



LF="0a"x                                  /* LF (line-feed) character                        */
TAB="09"x
.local~maxLength=200                      /* maximum of 200 chars of result                  */

signal on syntax

if oDoc~uno.queryServiceName("TextDocument")<>"" then    /* a TextDcoument in hand?             */
do
   xTextDoc=oDoc~XTextDocument            /* get the XTextDocument interface                 */
   xTextDoc~getText~getEnd~setString(str) /* add text at the end of the text document        */

   xTextDoc~getText~getEnd~setString(LF LF) /* add text at the end of the text document        */
   do i=1 to methods~items
      methodName=methods[i]
      xTextDoc~getText~getEnd~setString(methodName":"TAB) /* add text at the end of the text document        */
      xTextDoc~getText~getEnd~setString(pp(getValue(metaData,methodName)) LF) /* add text at the end of the text document        */
   end
end
else if oDoc~uno.queryServiceName("SpreadsheetDocument")<>"" then /* a SpreadsheetDocument?     */
do
   xSheet = oDoc~XSpreadSheetDocument~getSheets~XIndexAccess~getByIndex(0)~XSpreadSheet
   cell=uno.getCell(xSheet, "A1")            /* get cell object                                 */
   -- or: cell=uno.getCell(xSheet, 0, 0)     /* co-ordinates as 0-based numbers                 */
   text=cell~getFormula                      /* get unedited text                               */
   -- or: text=cell~XText~getString          /* use the XText interface method "getString"      */

   if text<>"" then str=text str             /* add "str" to existing text                      */

   call uno.setCell xSheet, "A1", str        /* set the text in the cell                        */
   -- or: call uno.setCell xSheet, 0, 0, str /* co-ordinates as 0-based numbers                 */

   do i=1 to methods~items
      line=i+2
      methodName=methods[i]

      call uno.setCell xSheet, "A"line, methodName
      call uno.setCell xSheet, "B"line, pp(getValue(metaData,methodName))
   end

end
else  /* an unknown document type, display its implemented service(s)   */
do
   tmpStr=""

   do i=1 to methods~items
      methodName=methods[i]
      tmpStr=tmpStr || methodName":"TAB || pp(getValue(metaData,methodName)) || LF
   end

   url=oDoc~getUrl                           /* get Document's name (an URL)                    */
   if url<>"" then tmpStr="Document URL/Name:" url LF LF tmpStr

   title="ScriptMetaData Information"
   .bsf.dialog~messageBox(tmpStr, title, "information")
end
      /* <== replace the previous part with your code (end)   */

exit

syntax:
   o=condition("O")     -- get condition object
   LF="0a"x
   TAB="        "

   tmpStr=""
   do idx over o~makeArray~sort
      val=o[idx]
      tmpStr=tmpStr || (idx || ":")~left(25) pp(val) LF

      if val~hasmethod("items") then   -- a collection? show its content
      do
         do item over val
            tmpStr=tmpStr || tab || tab || pp(item) || LF
         end
      end

   end

   if length(tmpStr)>750 then tmpStr=left(tmpStr,750)"..."

   if var("BSF_ERROR_MESSAGE") | .local~hasEntry("BSF_ERROR_MESSAGE") then -- a BSF error message ?
   do
      if var("BSF_ERROR_MESSAGE") then errStr=BSF_ERROR_MESSAGE
                                  else errStr=.bsf_error_message

      tmpStr=tmpStr LF LF || "-"~copies(80) LF
      tmpStr=tmpStr          "*** BSF4Rexx Error Information: ***" LF LF
      if length(errStr)>1000 then
         tmpStr=tmpStr || left(errStr,1000)"..."
      else
         tmpStr=tmpStr || errStr
   end

   .bsf.dialog~messageBox(tmpStr, "Runtime error #" o~code, "error")




::requires UNO.CLS   /* load UNO support (OpenOffice/StarOffice) for ooRexx   */

::routine getValue
  use arg metaData, methodName

  signal on syntax
      -- send message, retrieve value
  val=.message~new(metaData,methodName)~send
  if val~isA(.BSF) then val=val~toString

      -- make sure not too long
  if length(val)>.maxLength then
     val=val~left(.maxLength)"..."

  return val


   /* save value of BSF_ERROR_MESSAGE in .local, otherwise we have no access in caller! */
syntax:                 -- intercept exception
  if var("BSF_ERROR_MESSAGE") then
    .local~bsf_error_message=bsf_error_message
  raise propagate       -- now raise exception in caller




